var xps = {
  "init" : function() {
    var selection = this.trim(this.getSelectedText());
    var selectionOutput = selection;
    if (selectionOutput.length > 32) {
      selectionOutput = selectionOutput.substring(0, 30) + "...";
    }
    if (selection.length > 75) {
      selection = selection.substring(0, 75);
    }
    
    var domain = window._content.location.host + ""; // toString
    if (domain.substring(0, 4) == "www.") {
      domain = domain.substring(4);
    }
    
    var domainName = domain.substring(0, domain.lastIndexOf("."));
    var domainQuery = domain + " OR " + domainName;
    var companyName1 = domainName;
    
    if (domainName.indexOf(".") != -1) {
      // subdomain
      companyName1 = domainName.substring(domainName.lastIndexOf(".") + 1);
      domainQuery += " OR "+ companyName1;
    }
    
    if (domainName.indexOf("-") != -1) {
      // domain with "-"
      var companyName2 = "\"" + companyName1.split("-").join(" ") + "\"";
      domainQuery += " OR "+ companyName2;
    }
    // company name in meta tag "author"
    var metaTags = window._content.document.getElementsByTagName("meta");
    for (var i=0; i<metaTags.length; i++) {
      if (metaTags[i].name.toLowerCase() == "author" && metaTags[i].content.length > 3 && metaTags[i].content.indexOf('@') == -1) {
        domain = metaTags[i].content;
        domainQuery += " OR " + "\"" + domain +"\"";
      }
    }
    
    // get language resources
    var resources = document.getElementById("xingpeoplesearch-strings");
    var menuItemXingText = resources.getString("xps_find_keyword");
    var menuItemXingEmpText = resources.getString("xps_find_employees");
    // menu items
    var menuItemXing = document.getElementById("xps_mi_xing");
    var menuItemXingEmp = document.getElementById("xps_mi_xing_emp");
    
    // display in context menu
    if (selection.length > 2) {
      menuItemXing.setAttribute("disabled", false);
      menuItemXing.setAttribute("label", menuItemXingText.replace('...', selectionOutput));
      menuItemXing.setAttribute("oncommand", "xps.openXing('"+ selection + "');");
    } else {
      menuItemXing.setAttribute("disabled", true);
      menuItemXing.setAttribute("label", menuItemXingText);
    }
    
    if (domain.length > 3) {
      menuItemXingEmp.setAttribute("disabled", false);
      menuItemXingEmp.setAttribute("label", menuItemXingEmpText.replace('...', domain));
      menuItemXingEmp.setAttribute("oncommand", "xps.openXingForCompany('" + domainQuery + "');");
    } else {
      menuItemXingEmp.setAttribute("disabled", true);
      menuItemXingEmp.setAttribute("label", menuItemXingEmpText);
    }
  },
  
  "getSelectedText" : function() {
    var s = "";
    if (window._content && window._content.getSelection() && window._content.getSelection() != "") {
        s = window._content.getSelection();
    } else {
      if (!gContextMenu) {
        if (!s || s == "") {
            var oFE = document.commandDispatcher.focusedElement;
            if(oFE && oFE.value) s = oFE.value.substring(oFE.selectionStart, oFE.selectionEnd);
        }
      } else if (gContextMenu.onTextInput) {
        var node = document.popupNode;
        s = node.value.substring(node.selectionStart, node.selectionEnd);
      } else {
        if (gContextMenu.isTextSelected) {
          var focusedWindow = document.commandDispatcher.focusedWindow;
          if (focusedWindow == window) focusedWindow = window._content;
          s = focusedWindow.getSelection();
        } else {
          if (gContextMenu.target) {
            if (gContextMenu.target.title) {
              s = gContextMenu.target.title;
            } else if (gContextMenu.target.alt) {
              s = gContextMenu.target.alt;
            }
          }
        }
      }
    }    
    return (s + "");
  },
  
  "trim" : function(str) {
    str = str.replace(/^\s*(.*)/, "$1");
    str = str.replace(/(.*?)\s*$/, "$1");
    return str;
  },
  
  "openXing" : function(query) {
    openNewTabWith("https://www.xing.com/search/people?search[q]=" + encodeURIComponent(query), null, null, true);
  },
  
  "openXingForCompany" : function(query) {
    openNewTabWith("https://www.xing.com/app/search?op=combined;company=" + encodeURIComponent(query), null, null, true);
  }
};